

#include <i2clcdaqm.h>
#include <Arduino.h>
#include <Wire.h>
 
i2clcdaqm::i2clcdaqm( )
    {
	_v5or33 = 3;
	_br =0x23;
	_addr = 0x3E;
}
i2clcdaqm::i2clcdaqm(byte v5or33) {
	_v5or33 = v5or33;
	_br = 0x23;
	_addr = 0x3E;
}
i2clcdaqm::i2clcdaqm(byte v5or33,byte lbr) {
	_v5or33 = v5or33;
	_br = lbr;
	_addr = 0x3E;
}
i2clcdaqm::i2clcdaqm(byte v5or33,byte lbr,byte i2cadr){
	_v5or33 = v5or33;
	_br = lbr;
	_addr = i2cadr;
}
int i2clcdaqm::i2cwritecmd(byte cmd){
  Wire.beginTransmission(_addr);
  Wire.write(0x00);
  Wire.write(cmd);
  return Wire.endTransmission();
}
int i2clcdaqm::i2cwritedata(byte data){
  Wire.beginTransmission(_addr);
  Wire.write(0x40);
  Wire.write(data);
  return Wire.endTransmission();
}
void i2clcdaqm::lcdcu_set(int x, int y) {
  byte ca = (x + y * 0x40) | (0x80);  i2cwritecmd(ca);
}
void i2clcdaqm::lcdclear() {
Serial.println( i2cwritecmd(0x01));  delay(1);
}
void i2clcdaqm::lcdhome() {
  i2cwritecmd(0x02);  delay(1);
}
void i2clcdaqm::dsift_l() {
  i2cwritecmd(0x18);
}
void i2clcdaqm::dsift_r() {
  i2cwritecmd(0x1C);
}
void i2clcdaqm::init_lcd() {
	byte bon = 0;
	delay(145);
	i2cwritecmd(0x38); delay(1);//
	i2cwritecmd(0x38); delay(1); //
           byte contrast = (0x70 | (_br & 0x0F));
       	if (_v5or33 == 5) {
                     bon=0;
		}
		else {
                     bon=0x04;	
		}
    byte powercmd = ((0x50 | (bon )| (_br >> 4)));
                     Serial.println(powercmd);
                     Serial.println(contrast);
		i2cwritecmd(0x39);  delay(1);
		i2cwritecmd(0x14);  delay(1);
		i2cwritecmd(contrast);  delay(1);
        i2cwritecmd(powercmd);  delay(2);
		i2cwritecmd(0x6C);  delay(300);
		i2cwritecmd(0x38);  delay(1);
	
	i2cwritecmd(0x01);  delay(2);
	i2cwritecmd(0x0C);  delay(2);
}

void i2clcdaqm::i2cprint( String pdata) {
  int n = pdata.length();
  for (int i = 0; i < n; i = i + 1) {
    i2cwritedata( pdata.charAt(i));
    delay(1);
  }
}
